#include "stdafx.h"

#include "JVMException.hpp"

#include <assert.h>

#include <string>

JVMException::JVMException( const char* v_message )
	: std::runtime_error( v_message )
{
}

/*!
 * JavaVMŗOĂ邩`FbNAĂJVMExceptionO𔭐܂B
 * \param env JNIANZX̂߂̃XbhƂ̊
 */
void JVMException::checkAndThrow( JNIEnv* env ) throw( JVMException )
{
	//required:
	assert( env != NULL );

	//do:
	jthrowable err = env->ExceptionOccurred();
	env->ExceptionClear();
	if( err != NULL ) {
		jclass throwableClass = env->GetObjectClass( err );
		jmethodID toStringMethodID = env->GetMethodID( throwableClass, "toString", "()Ljava/lang/String;" );
		assert( toStringMethodID != NULL );
		jstring errDescription = reinterpret_cast<jstring>(env->CallObjectMethod( err, toStringMethodID ));
		const char* szErrDescription = env->GetStringUTFChars( errDescription, NULL );
		std::string message( szErrDescription );
		env->ReleaseStringUTFChars( errDescription, szErrDescription );
		throw JVMException( message.c_str() );
	}
}

